# I3DShWireFrameSet Struct Reference
[Shell Interfaces]

Inheritance diagram for I3DShWireFrameSet:

List of all members.

## Public Member Functions
virtual boolean MCCOMAPI | HasNoEmptyList ()=0
virtual void MCCOMAPI | AllocateLists (int32 pointListsCount, int32 connectionListsCount)=0
virtual int32 MCCOMAPI | GetListsCount (EWFListType inListType) const =0
| Returns the number of lists of the given type.
virtual TWFPointList &MCCOMAPI | GetPointList (int32 pointListIndex)=0
virtual TWFConnectionList &MCCOMAPI | GetConnectionList (int32 connectionListIndex)=0
virtual void MCCOMAPI | InvalidateCache ()=0
virtual void MCCOMAPI | GetColor (EWFListType inListType, int32 inListIndex, TMCColorRGB &outColor) const =0
virtual void MCCOMAPI | SetColor (EWFListType inListType, int32 inListIndex, const TMCColorRGB &inColor)=0
virtual void MCCOMAPI | Transform (const TTreeProjectionTransform &trans)=0
virtual boolean MCCOMAPI | TestHit (const TVector2 &inScreenPoint, const real inMaxHitError, const int32 inSelectionMask, const boolean selectBehindCamera, TWFHitInfo &outInfo) const =0
virtual void MCCOMAPI | AddRenderables (TMCPtrArray< I3DShRenderable > &renderables)=0
virtual boolean MCCOMAPI | HasWFExcludedFromZBuffer () const =0
virtual void MCCOMAPI | SetSelectedState (const boolean selected)=0

## Detailed Description

Used for wireframe controls in the 3dview Stores a list of TWFPointList and a list of TWFConnectionList

## Member Function Documentation

virtual void MCCOMAPI I3DShWireFrameSet::AddRenderables | ( | TMCPtrArray< I3DShRenderable > & | renderables | ) | `[pure virtual]`

Adds the renderables.

virtual void MCCOMAPI I3DShWireFrameSet::AllocateLists | ( | int32 | pointListsCount,
|  | int32 | connectionListsCount |
| ) |  |  | `[pure virtual]`

Allocates the lists of points and connections (segments).

Parameters:

  | pointListsCount | The number of list of points.
  | connectionListsCount | The number of list of connections (segments).

virtual void MCCOMAPI I3DShWireFrameSet::GetColor | ( | EWFListType | inListType,
|  | int32 | inListIndex,
|  | TMCColorRGB & | outColor |
| ) |  |  | const`[pure virtual]`

Returns the color of the elements of a list.

Parameters:

  | inListType | The type of list (segment or points)
  | inListIndex | The index of the list.
  | outColor | The color of the elements.

virtual TWFConnectionList& MCCOMAPI I3DShWireFrameSet::GetConnectionList | ( | int32 | connectionListIndex | ) | `[pure virtual]`

Returns a reference to a connection list.

Parameters:

  | connectionListIndex |

virtual int32 MCCOMAPI I3DShWireFrameSet::GetListsCount | ( | EWFListType | inListType | ) | const`[pure virtual]`

Returns the number of lists of the given type.

virtual TWFPointList& MCCOMAPI I3DShWireFrameSet::GetPointList | ( | int32 | pointListIndex | ) | `[pure virtual]`

Returns a reference to a point list.

Parameters:

  | pointListIndex | The index of the point list.

virtual boolean MCCOMAPI I3DShWireFrameSet::HasNoEmptyList | ( |  | ) | `[pure virtual]`

Call this function in an assert after building the set to check that every list is "valid"

virtual boolean MCCOMAPI I3DShWireFrameSet::HasWFExcludedFromZBuffer | ( |  | ) | const`[pure virtual]`

Returns true if some wireframes are excluded from the Z buffer

virtual void MCCOMAPI I3DShWireFrameSet::InvalidateCache | ( |  | ) | `[pure virtual]`

Call this if you modify the positions/connections of an existing object (AllocateLists does it for you)

virtual void MCCOMAPI I3DShWireFrameSet::SetColor | ( | EWFListType | inListType,
|  | int32 | inListIndex,
|  | const TMCColorRGB & | inColor |
| ) |  |  | `[pure virtual]`

Sets the color of the elements of a list.

Parameters:

  | inListType | The type of list (segment or points)
  | inListIndex | The index of the list.
  | inColor | The color of the elements.

virtual void MCCOMAPI I3DShWireFrameSet::SetSelectedState | ( | const boolean | selected | ) | `[pure virtual]`

Sets the selection state of the wireframe.

virtual boolean MCCOMAPI I3DShWireFrameSet::TestHit | ( | const TVector2 & | inScreenPoint,
|  | const real | inMaxHitError,
|  | const int32 | inSelectionMask,
|  | const boolean | selectBehindCamera,
|  | TWFHitInfo & | outInfo |
| ) |  |  | const`[pure virtual]`

Returns true if one of the set's elements was hit

Parameters:

  | inScreenPoint | The screen point in uv camera space
  | inMaxHitError | The selection zone arround each element
  | inSelectionMask | A bitfield of EWFElementType values used to ignore some elements
  | outInfo | The infomation about whic element was hit. Not modified if there is no hit.

virtual void MCCOMAPI I3DShWireFrameSet::Transform | ( | const TTreeProjectionTransform & | trans | ) | `[pure virtual]`

Return the transform of the wireframe set.

Parameters:

  | trans |

The documentation for this struct was generated from the following file:

- I3DWireFrameSet.h